
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#include <sbkpep.h>
#include <sbkpepbuffer.h>

#define PYSIDE6_COMOPT_COMPRESS 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "akonadicore_python.h"

// main header
#include "akonadi_entitydeletedattribute_wrapper.h"

// Wrappers providing overrides
#include "akonadi_exception_wrapper.h"
#include "akonadi_attribute_wrapper.h"

// Argument includes
#include <QString>
#include <collection.h>
#include <entitydeletedattribute.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace Akonadi;

extern "C" {
static PyTypeObject *Sbk_Akonadi_EntityDeletedAttribute_TypeF(void)
{
    return SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX].type;
}
} // extern "C"

// Native ---------------------------------------------------------

void EntityDeletedAttributeWrapper::resetPyMethodCache()
{
    std::fill(m_PyMethodCache.begin(), m_PyMethodCache.end(), nullptr);
}

EntityDeletedAttributeWrapper::EntityDeletedAttributeWrapper()
{
}

::Akonadi::EntityDeletedAttribute * EntityDeletedAttributeWrapper::clone() const
{
    static const char *funcName = "clone";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_EntityDeletedAttribute_TypeF(), gil, funcName, m_PyMethodCache[0], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::EntityDeletedAttribute::clone();
    }
    return sbk_o_clone("EntityDeletedAttribute", funcName, gil, pyOverride);
}

::Akonadi::EntityDeletedAttribute * EntityDeletedAttributeWrapper::sbk_o_clone([[maybe_unused]] const char *ownerClassName, [[maybe_unused]] const char *funcName, [[maybe_unused]] Shiboken::GilState &gil, [[maybe_unused]] const Shiboken::AutoDecRef &pyOverride)
{
#if defined(PYPY_VERSION)
    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));
#endif

#if !defined(PYPY_VERSION)
    Shiboken::AutoDecRef pyResult(PyObject_CallNoArgs(pyOverride));
#else
    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
#endif
    if (pyResult.isNull()) {
        // An error happened in python code!
        Shiboken::Errors::storePythonOverrideErrorOrPrint(ownerClassName, funcName);
        return nullptr;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), pyResult);
    if (!pythonToCpp) {
        Shiboken::Warnings::warnInvalidReturnValue(ownerClassName, funcName, PepType_GetFullyQualifiedNameStr(Shiboken::SbkType< Akonadi::EntityDeletedAttribute >()), Py_TYPE(pyResult)->tp_name);
        return nullptr;
    }
    ::Akonadi::EntityDeletedAttribute *cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

void EntityDeletedAttributeWrapper::deserialize(const ::QByteArray & data)
{
    static const char *funcName = "deserialize";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_EntityDeletedAttribute_TypeF(), gil, funcName, m_PyMethodCache[1], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::EntityDeletedAttribute::deserialize(data);
    }
    AttributeWrapper::sbk_o_deserialize("EntityDeletedAttribute", funcName, gil, pyOverride, data);
}

::QByteArray EntityDeletedAttributeWrapper::serialized() const
{
    static const char *funcName = "serialized";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_EntityDeletedAttribute_TypeF(), gil, funcName, m_PyMethodCache[2], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::EntityDeletedAttribute::serialized();
    }
    return ExceptionWrapper::sbk_o_type("EntityDeletedAttribute", funcName, gil, pyOverride);
}

::QByteArray EntityDeletedAttributeWrapper::type() const
{
    static const char *funcName = "type";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_EntityDeletedAttribute_TypeF(), gil, funcName, m_PyMethodCache[3], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::EntityDeletedAttribute::type();
    }
    return ExceptionWrapper::sbk_o_type("EntityDeletedAttribute", funcName, gil, pyOverride);
}

EntityDeletedAttributeWrapper::~EntityDeletedAttributeWrapper()
{
    auto *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this, Sbk_Akonadi_EntityDeletedAttribute_TypeF());
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Akonadi_EntityDeletedAttribute_Init(PyObject *self, [[maybe_unused]] PyObject *args, [[maybe_unused]] PyObject *kwds)
{
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Akonadi::EntityDeletedAttribute >()))
        return -1;

    EntityDeletedAttributeWrapper *cptr{};
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        // EntityDeletedAttribute::EntityDeletedAttribute()
        cptr = new EntityDeletedAttributeWrapper();
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< Akonadi::EntityDeletedAttribute >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_clone(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // Attribute::clone()const->Akonadi::EntityDeletedAttribute*
        Akonadi::EntityDeletedAttribute * cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
            ? const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->::Akonadi::EntityDeletedAttribute::clone()
            : const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->clone();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_deserialize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp;

    // Overloaded function decisor
    // 0: Attribute::deserialize(const QByteArray&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // Attribute::deserialize(const QByteArray&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "deserialize", SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // Attribute::deserialize(const QByteArray&)
            Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? cppSelf->::Akonadi::EntityDeletedAttribute::deserialize(*cppArg0)
                : cppSelf->deserialize(*cppArg0);
        }
    }

     return Sbk_ReturnFromPython_None();
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_restoreCollection(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // EntityDeletedAttribute::restoreCollection()const->Akonadi::Collection
        Akonadi::Collection cppResult = const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->restoreCollection();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Collection_IDX]), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_restoreResource(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // EntityDeletedAttribute::restoreResource()const->QString
        QString cppResult = const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->restoreResource();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_serialized(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // Attribute::serialized()const->QByteArray
        QByteArray cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
            ? const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->::Akonadi::EntityDeletedAttribute::serialized()
            : const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->serialized();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_setRestoreCollection(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp;

    // Overloaded function decisor
    // 0: EntityDeletedAttribute::setRestoreCollection(const Akonadi::Collection&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Collection_IDX]), (pyArg)))) {
        overloadId = 0; // EntityDeletedAttribute::setRestoreCollection(const Akonadi::Collection&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setRestoreCollection", SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::Akonadi::Collection cppArg0_local;
        ::Akonadi::Collection *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // EntityDeletedAttribute::setRestoreCollection(const Akonadi::Collection&)
            cppSelf->setRestoreCollection(*cppArg0);
        }
    }

     return Sbk_ReturnFromPython_None();
}

static PyObject *Sbk_Akonadi_EntityDeletedAttributeFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // Attribute::type()const->QByteArray
        QByteArray cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
            ? const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->::Akonadi::EntityDeletedAttribute::type()
            : const_cast<const ::Akonadi::EntityDeletedAttribute *>(cppSelf)->type();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}


static const char *Sbk_Akonadi_EntityDeletedAttribute_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Akonadi_EntityDeletedAttribute_methods[] = {
    {"clone", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_clone), METH_NOARGS, nullptr},
    {"deserialize", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_deserialize), METH_O, nullptr},
    {"restoreCollection", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_restoreCollection), METH_NOARGS, nullptr},
    {"restoreResource", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_restoreResource), METH_NOARGS, nullptr},
    {"serialized", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_serialized), METH_NOARGS, nullptr},
    {"setRestoreCollection", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_setRestoreCollection), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_Akonadi_EntityDeletedAttributeFunc_type), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_Akonadi_EntityDeletedAttribute_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::Akonadi::EntityDeletedAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<EntityDeletedAttributeWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_Akonadi_EntityDeletedAttribute_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Akonadi_EntityDeletedAttribute_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}

// Class Definition -----------------------------------------------
extern "C" {

static PyType_Slot Sbk_Akonadi_EntityDeletedAttribute_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_Akonadi_EntityDeletedAttribute_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Akonadi_EntityDeletedAttribute_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Akonadi_EntityDeletedAttribute_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Akonadi_EntityDeletedAttribute_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Akonadi_EntityDeletedAttribute_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Akonadi_EntityDeletedAttribute_spec = {
    "1:AkonadiCore.Akonadi.EntityDeletedAttribute",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Akonadi_EntityDeletedAttribute_slots
};

} //extern "C"

static void *Sbk_Akonadi_EntityDeletedAttribute_typeDiscovery([[maybe_unused]] void *cptr, [[maybe_unused]] PyTypeObject *instanceType)
{
    if (instanceType == Shiboken::SbkType< ::Akonadi::Attribute >())
        return dynamic_cast< ::Akonadi::EntityDeletedAttribute *>(reinterpret_cast< ::Akonadi::Attribute *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void EntityDeletedAttribute_PythonToCpp_EntityDeletedAttribute_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Akonadi_EntityDeletedAttribute_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_EntityDeletedAttribute_PythonToCpp_EntityDeletedAttribute_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Akonadi_EntityDeletedAttribute_TypeF()))
        return EntityDeletedAttribute_PythonToCpp_EntityDeletedAttribute_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *EntityDeletedAttribute_PTR_CppToPython_EntityDeletedAttribute(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn, Sbk_Akonadi_EntityDeletedAttribute_TypeF()));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    auto *tCppIn = reinterpret_cast<const ::Akonadi::EntityDeletedAttribute *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    return Shiboken::Object::newObjectForPointer(Sbk_Akonadi_EntityDeletedAttribute_TypeF(), const_cast<void *>(cppIn), false, typeName);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Akonadi_EntityDeletedAttribute_SignatureStrings[] = {
    "AkonadiCore.Akonadi.EntityDeletedAttribute(self)",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.clone(self)->AkonadiCore.Akonadi.EntityDeletedAttribute",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.deserialize(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.restoreCollection(self)->AkonadiCore.Akonadi.Collection",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.restoreResource(self)->QString",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.serialized(self)->PySide6.QtCore.QByteArray",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.setRestoreCollection(self,col:AkonadiCore.Akonadi.Collection)",
    "AkonadiCore.Akonadi.EntityDeletedAttribute.type(self)->PySide6.QtCore.QByteArray",
    nullptr}; // Sentinel
#else
static constexpr size_t Akonadi_EntityDeletedAttribute_SignatureByteSize = 192;
static constexpr uint8_t Akonadi_EntityDeletedAttribute_SignatureBytes[192] = {
    0x78, 0xda, 0x9d, 0x91, 0x3d, 0x0f, 0x82, 0x30, 0x10, 0x86, 0x77, 0x7f, 0x85, 0xa3, 0x1a, 0xec,
    0xe8, 0xc0, 0x60, 0x52, 0xd1, 0x5d, 0x20, 0x4e, 0xc6, 0xa1, 0xb6, 0x27, 0x5e, 0x6c, 0x5a, 0x53,
    0x8e, 0xa1, 0xfe, 0x7a, 0x1b, 0x51, 0x5c, 0x14, 0xa9, 0xdb, 0x0d, 0xef, 0xc7, 0xdd, 0x73, 0xfc,
    0x62, 0x8d, 0x50, 0x98, 0x59, 0x07, 0x8c, 0xb7, 0x33, 0xdb, 0x18, 0x42, 0xf2, 0x6b, 0xd0, 0x40,
    0xa0, 0x38, 0x91, 0xc3, 0x63, 0x43, 0x30, 0xa9, 0x41, 0x9f, 0xa6, 0x23, 0x3e, 0xd8, 0xc0, 0xa4,
    0xb6, 0xe6, 0x69, 0x9b, 0x2f, 0x87, 0xfb, 0x62, 0x2a, 0x14, 0xd4, 0xe0, 0x50, 0x68, 0xbc, 0xb5,
    0x45, 0x89, 0x12, 0x24, 0x52, 0xf2, 0x57, 0x34, 0x15, 0xdb, 0x19, 0xb4, 0x66, 0xbf, 0xf5, 0x25,
    0x2a, 0x58, 0xb0, 0x9c, 0x1e, 0x81, 0xf9, 0xca, 0x13, 0x70, 0xe7, 0x84, 0x4f, 0xc6, 0xf2, 0x2c,
    0xdc, 0xec, 0x10, 0x75, 0x93, 0x83, 0x9a, 0x82, 0x2c, 0xb3, 0x5a, 0x83, 0xa4, 0x90, 0xdf, 0x77,
    0xdf, 0x5b, 0xf5, 0x47, 0x45, 0x01, 0xb5, 0x6d, 0x9c, 0xec, 0x00, 0xe6, 0x65, 0x10, 0x98, 0x2a,
    0x26, 0xa9, 0x63, 0xa3, 0x5e, 0x21, 0x5f, 0x61, 0xc4, 0xc5, 0x52, 0xf1, 0x11, 0x43, 0x22, 0xad,
    0x4e, 0xfb, 0x41, 0x44, 0xc1, 0x0e, 0x7f, 0x84, 0xdf, 0x9b, 0xdf, 0x01, 0xdc, 0x10, 0x07, 0xca
};
#endif

PyTypeObject *init_Akonadi_EntityDeletedAttribute(PyObject *enclosingClass)
{
    auto &typeStruct = SbkAkonadiCoreTypeStructs[SBK_Akonadi_EntityDeletedAttribute_IDX];
    if (typeStruct.type != nullptr)
        return typeStruct.type;

    auto *base1 = reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkAkonadiCoreTypeStructs[SBK_Akonadi_Attribute_IDX]));
    Shiboken::AutoDecRef Sbk_Akonadi_EntityDeletedAttribute_Type_bases(PyTuple_Pack(1, base1));

    PyTypeObject *pyType = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "EntityDeletedAttribute",
        "Akonadi::EntityDeletedAttribute*",
        &Sbk_Akonadi_EntityDeletedAttribute_spec,
        &Shiboken::callCppDestructor< Akonadi::EntityDeletedAttribute >,
        Sbk_Akonadi_EntityDeletedAttribute_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Akonadi_EntityDeletedAttribute_SignatureStrings);
#else
    InitSignatureBytes(pyType, Akonadi_EntityDeletedAttribute_SignatureBytes, Akonadi_EntityDeletedAttribute_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Akonadi_EntityDeletedAttribute_PropertyStrings);
    typeStruct.type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        EntityDeletedAttribute_PythonToCpp_EntityDeletedAttribute_PTR,
        is_EntityDeletedAttribute_PythonToCpp_EntityDeletedAttribute_PTR_Convertible,
        EntityDeletedAttribute_PTR_CppToPython_EntityDeletedAttribute);

    Shiboken::Conversions::registerConverterName(converter, "Akonadi::EntityDeletedAttribute");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::EntityDeletedAttribute*");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::EntityDeletedAttribute&");
    Shiboken::Conversions::registerConverterAlias(converter, "EntityDeletedAttribute");
    Shiboken::Conversions::registerConverterAlias(converter, "EntityDeletedAttribute*");
    Shiboken::Conversions::registerConverterAlias(converter, "EntityDeletedAttribute&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Akonadi::EntityDeletedAttribute).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(EntityDeletedAttributeWrapper).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(pyType, &Sbk_Akonadi_EntityDeletedAttribute_typeDiscovery);

    qRegisterMetaType< ::Akonadi::EntityDeletedAttribute *>();

    return pyType;
}
